---
title: XMLHttpRequestResponseType
slug: Web/API/XMLHttpRequestResponseType
tags:
  - Definition
  - Enum
  - Enumerated
  - Response
  - Response Type
  - Type
  - XMLHttpRequest
  - XMLHttpRequestResponseType
---
<div>{{APIRef("XMLHttpRequest")}}</div>

<p><span class="seoSummary">The <code><strong>XMLHttpRequestResponseType</strong></code> type is an enumerated set of strings which are used to specify the type of data contained in the {{domxref("XMLHttpRequest.response", "response")}} of an {{domxref("XMLHttpRequest")}}.</span> These values are used when getting or setting the {{domxref("XMLHttpRequest.responseType", "responseType")}} on the request.</p>

<h2 id="Values">Values</h2>

<dl>
 <dt><code>""</code></dt>
 <dd>An empty <code>responseType</code> string is treated the same as <code>"text"</code>, the default type.</dd>
 <dt><code>arraybuffer</code></dt>
 <dd>The {{domxref("XMLHttpRequest.response", "response")}} is a JavaScript {{jsxref("ArrayBuffer")}} containing binary data.</dd>
 <dt><code>blob</code></dt>
 <dd>The <code>response</code> is a {{domxref("Blob")}} object containing the binary data.</dd>
 <dt><code>document</code></dt>
 <dd>The <code>response</code> is an {{Glossary("HTML")}} {{domxref("Document")}} or {{Glossary("XML")}} {{domxref("XMLDocument")}}, as appropriate based on the MIME type of the received data. See <a href="/en-US/docs/Web/API/XMLHttpRequest/HTML_in_XMLHttpRequest">HTML in XMLHttpRequest</a> to learn more about using XHR to fetch HTML content.</dd>
 <dt><code>json</code></dt>
 <dd>The <code>response</code> is a JavaScript object created by parsing the contents of received data as {{Glossary("JSON")}}.</dd>
 <dt><code>text</code></dt>
 <dd>The <code>response</code> is a text in a {{domxref("DOMString")}} object.</dd>
 <dt><code>ms-stream</code> {{non-standard_inline}}</dt>
 <dd>The <code>response</code> is part of a streaming download; this response type is only allowed for download requests, and is only supported by Internet Explorer.</dd>
</dl>

<h2 id="Deprecated_values">Deprecated values</h2>

<dl>
 <dt><code>moz-chunked-arraybuffer</code> {{non-standard_inline}}</dt>
 <dd>
 <p>A Firefox-only value which instructs <code>XMLHttpRequest</code> to deliver {{domxref("ArrayBuffer")}} objects containing chunks of the incoming data. Accessing <code>response</code> during a <code>progress</code> event returns the data received so far. Outside the <code>progress</code> event handler, the value of <code>response</code> is always <code>null</code>. You shouldn't use this non-standard (and, as of Firefox 68, entirely removed) API; instead, consider using <a href="/en-US/docs/Web/API/Streams_API/Using_readable_streams#Consuming_a_fetch_as_a_stream">the Fetch API with readable streams</a>, which offers a standard alternative to accessing the response in a streaming fashion.</p>
 </dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('XMLHttpRequest')}}</td>
   <td>{{Spec2('XMLHttpRequestResponseType')}}</td>
   <td>Live standard, latest version</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.responseType")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/HTML_in_XMLHttpRequest">HTML in XMLHttpRequest</a></li>
</ul>
